
#include "translator.h"

#define MAX_STRING 5000

#include <fstream>
#include <iostream>
using namespace std;

int main (int argc, char* argv[])
{
	if (argc > 2)
	{
		cout << "USAGE: ifsql [filename]\n";
		return 1;
	}
	FILE* f;
	if (argc == 1)
		f = stdin;
	else
	{
		f = fopen (argv[1], "r");
		if (!f)
		{
			cout << "Can't open file " << argv[1] << endl;
			return 1;
		}
	}
	
	char src [MAX_STRING];
	while (!feof(f))
		src [fread (src, 1, MAX_STRING, f)] = 0;
	const char* buf;
	const IfsqlError* ifsqlError = translateIFSQL (&buf, src);
	if (ifsqlError)
	{
		if (ifsqlError->token)
			cout << "[IFSQL] " << ifsqlError->message << " at or near \"" << ifsqlError->token
				<< "\" at character " << ifsqlError->cursorpos << endl;
		else
			cout << "[IFSQL] " << ifsqlError->message << " at end of input\n";
		return 1;
	}
	cout << buf << endl;
	return 0;
}
